Menu

- Learn
- Documentation
  - Language Reference
  - Library Reference
  - Command-line Reference
  - Feature Overview
  - Articles
- Downloads
- Packages
- Community
  - Blog
  - Orgs using D
  - Twitter
  - Calendar
  - Forums
  - IRC
  - Community Discord
  - Wiki
  - GitHub
  - Issues
  - Get involved
  - Contributors
  - Foundation
  - Security Team
  - Donate
  - Sponsors
- Resources
  - Tour
  - Books
  - Tutorials
  - Tools
  - Editors
  - IDEs
  - run.dlang.io
  - Visual D
  - Acknowledgments
  - D Style
  - Glossary
  - Sitemap

Search
Report a bug
If you spot a problem with this page, click here to create a Bugzilla issue.
Improve this page
Quickly fork, edit online, and submit a pull request for this page. Requires a signed-in GitHub account. This works well for small changes. If you'd like to make larger changes you may want to consider using a local clone.

# dmd.cli

Compiler implementation of the D programming language.
This modules defines the help texts for the CLI options offered by DMD. This file is not shared with other compilers which use the DMD front-end. However, this file will be used to generate the online documentation and MAN pages.
Authors:
Walter Bright
License:
Boost License 1.0

Source cli.d

Documentation https://dlang.org/phobos/dmd_cli.html

Coverage https://codecov.io/gh/dlang/dmd/src/master/src/dmd/cli.d

enum `TargetOS`: int;
  Bit decoding of the TargetOS
bool `isCurrentTargetOS`(TargetOS `os`);
  Checks whether `os` is the current TargetOS. For TargetOS.all it will always return true.
  Parameters:

  TargetOS `os` | TargetOS to check

  Returns:
  true iff `os` contains the current targetOS.
static string `capitalize`(string `w`);
  Capitalize a the first character of a ASCII string.
  Parameters:

  string `w` | ASCII i string to capitalize

  Returns:
  capitalized string
struct `Usage`;
  Contains all available CLI Usage.Options.
  See Also:
  Usage.Option
  struct `Option`;
    Representation of a CLI `Option`
    The DDoc description ddoxText is only available when compiled with -version=DdocOptions.
    string `flag`;
      The CLI flag without leading -, e.g. color
    string `helpText`;
      A detailed description of the flag
    TargetOS `os`;
      For which TargetOS the flags are applicable
    this(string `flag`, string `helpText`, TargetOS `os` = TargetOS.all);
    this(string `flag`, string `helpText`, string `ddocText`, TargetOS `os` = TargetOS.all);
      Parameters:

      string `flag` | CLI flag without leading -, e.g. color
      string `helpText` | detailed description of the flag
      TargetOS `os` | for which TargetOS the flags are applicable
      string `ddocText` | detailed description of the flag (in Ddoc)

  static immutable Option[] `options`;
    Returns all available CLI options
  struct `Feature`;
    Representation of a CLI feature
    string `name`;
      name of the feature
    bool `deprecated_`;
      whether the feature is still in use
  static immutable Feature[] `transitions`;
    Returns all available transitions
  static immutable Feature[] `reverts`;
    Returns all available reverts
  static immutable Feature[] `previews`;
    Returns all available previews
struct `CLIUsage`;
  Formats the Options for CLI printing.
  static string `usage`();
    Returns a string of all available CLI options for the current targetOS. Options are separated by newlines.
  enum string `mcpuUsage`;
    CPU architectures supported -mcpu=id
  enum string `transitionUsage`;
    Language changes listed by -transition=id
  enum string `revertUsage`;
    Language changes listed by -revert
  enum string `previewUsage`;
    Language previews listed by -preview
  enum string `checkActionUsage`;
    Options supported by -checkaction=
  enum string `checkUsage`;
    Options supported by -check
  enum string `externStdUsage`;
    Options supported by -extern-std

Copyright © 1999-2020 by the D Language Foundation | Page generated by Ddoc on Mon Mar 9 06:16:47 2020